let MongoClient = require('mongodb').MongoClient;
const COLLECTION = 'postStats';

module.exports = class DB {
    constructor(url, name) {
        this.url = url;
        this.name = name;
    }

    async connect() {
        let client;
        try {
            client = await MongoClient.connect(this.url,{ useNewUrlParser: true });
        } catch (e) {
            console.log(e);
            process.kill('SIGTERM');
        }
        this.client = client;
        this.db = client.db(this.name);
    }

    async save(record) {
        if (process.env.STATS_TO_CONSOLE) {
            console.log(`db saves: \n\ttime: ${record.time} \n\t${record.server} \n\t${record.posts} posts (${record.batchSize} statements)\n\t${record.roundtrip} avg roundtrip`);
        }
        await this.db.collection(COLLECTION).insertOne(record);
    }

    close() {
        this.client.close();
        console.log('closed db');
    }
}