/** ***********************************************************************
 *
 * Veracity Technology Consultants CONFIDENTIAL
 * __________________
 *
 *  2017 Veracity Technology Consultants
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Veracity Technology Consultants and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Veracity Technology Consultants
 * and its suppliers and may be covered by U.S. and Foreign Patents,
 * patents in process, and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Veracity Technology Consultants.
 */

const graphConfig = require('./graphConfig.js');

module.exports = class errorBars extends graphConfig {
    constructor(categoryField, valueField, errorField, maximum, minimum) {
        super('graph');
        (this.type = 'serial'), (this.labelsEnabled = false);
        this.engine = 'amcharts';
        this.categoryField = categoryField;
        this.rotate = false;
        this.theme = 'light';
        this.startDuration = 1;
        this.startEffect = 'easeInSine';
        this.marginBottom = 10;
        this.marginLeft = 10;
        this.marginRight = 10;
        this.marginTop = 10;

        this.categoryAxis = {
            gridPosition: 'start',
            gridAlpha: 0.02,
            rotateLabels: 80,
            autoRotateCount: 5,
            autoRotateAngle: 45,
            truncateLabel: 20,
        };
        this.valueAxes = [
            {
                axisAlpha: 0.2,
                gridAlpha: 0.02,
                id: 'v1',

                maximum,
                minimum,
            },
        ];

        this.graphs = [
            {
                autoColor: true,
                valueField,
                errorField: 'stdDev',
                bullet: 'yError',
                bulletSize: 20,
                lineThickness: 0,
                bulletAxis: 'v1',
                //     "fillAlphas": 0.0,
                balloonText: `avg:<b>[[${valueField}]]</b><br>stdDev:<b>[[${errorField}]]</b>`,
            },
            {
                bullet: 'round',
                bulletBorderAlpha: 1,
                bulletBorderColor: '#FFFFFF',
                lineAlpha: 0,
                lineThickness: 2,
                showBalloon: false,
                valueField,
            },
        ];

        this.update = function(params,data)
        {
            console.log(data);
            if(data.length < 20)
                this.display = "three_x_one"
            if(data.length < 15)
                this.display = "two_x_one"
            if(data.length < 10)
                this.display = "one_x_one"

            console.log(this.display)
        }
    }
};
