/** ***********************************************************************
 *
 * Veracity Technology Consultants CONFIDENTIAL
 * __________________
 *
 *  2017 Veracity Technology Consultants
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Veracity Technology Consultants and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Veracity Technology Consultants
 * and its suppliers and may be covered by U.S. and Foreign Patents,
 * patents in process, and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Veracity Technology Consultants.
 */

const graphConfig = require('./graphConfig.js');

module.exports = class GanttChart extends graphConfig {
    constructor(category, segments, start, end) {
        super('graph');
        this.type = 'gantt';
        this.engine = 'amcharts';
        this.theme = 'light';
        this.marginBottom = 10;
        this.marginLeft = 10;
        this.marginRight = 10;
        this.marginTop = 10;
        this.period = 'hh';
        //	this.dataDateFormat = "YYYY-MM-DDTJJ:MM:SS";
        this.balloonDateFormat = 'JJ:NN';
        this.columnWidth = 0.85;
        this.brightnessStep = 1;
        this.rotate = true;
        this.responsive = {
            enabled: false,
        };
        this.categoryField = category;
        this.segmentsField = segments;
        this.colorField = 'color';
        //	this.startDate = "2015-01-01";
        // this.maxSelectedSeries= 4;
        this.startDateField = start;
        this.endDateField = end;

        this.valueAxis = {
            type: 'date',
            parseDates: true,
            gridAlpha: 0.02,
        };
        this.graph = {
            fillAlphas: 1,
            balloonText: 'Course: <b>[[course]]</b>',
        };
        //	this.valueScrollbar = {
        //		"autoGridCount": true
        //	};
        this.chartScrollbar = {
            enabled: true,
            hideResizeGrips: true,
            resizeEnabled: false,
        };
        this.chartCursor = {
            cursorColor: '#2c98bb',
            valueBalloonsEnabled: false,
            cursorAlpha: 0,
            valueLineAlpha: 0.5,
            valueLineBalloonEnabled: true,
            valueLineEnabled: true,
            zoomable: false,
            valueZoomable: true,
        };
        this.export = {
            enabled: true,
        };
    }
};
