/** ***********************************************************************
 *
 * Veracity Technology Consultants CONFIDENTIAL
 * __________________
 *
 *  2017 Veracity Technology Consultants
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Veracity Technology Consultants and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Veracity Technology Consultants
 * and its suppliers and may be covered by U.S. and Foreign Patents,
 * patents in process, and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Veracity Technology Consultants.
 */

const graphConfig = require('./graphConfig.js');

module.exports = class Gauge extends graphConfig {
    constructor(percent, total, text) {
        super('graph');
        this.type = 'gauge';
        this.engine = 'amcharts';
        this.arrows = [];
        this.marginBottom = 10;
        this.marginLeft = 10;
        this.marginRight = 10;
        this.marginTop = 10;
        this.axes = [
            {
                bandAlpha: 0.53,
                bandOutlineAlpha: 1,
                bandOutlineThickness: 1,
                bottomText: text,
                bottomTextFontSize: 20,
                bottomTextYOffset: -73,
                endAngle: 90,
                endValue: 100,
                fontSize: 20,
                id: 'GaugeAxis-1',
                startAngle: -90,
                topText: `${percent}%`,
                topTextFontSize: 53,
                topTextYOffset: 66,
                unit: '%',
                valueInterval: 100,
                labelsEnabled: false,
                bands: [
                    {
                        color: '#00AFCC',
                        endValue: percent,
                        id: 'GaugeBand-1',
                        innerRadius: 157,
                        startValue: 0,
                    },
                ],
            },
            {
                endAngle: 90,
                gridInside: false,
                id: 'GaugeAxis-4',
                labelFrequency: 96,
                minorTickInterval: 93,
                minorTickLength: 4,
                radius: 162,
                showFirstLabel: false,
                showLastLabel: false,
                startAngle: -90,
                tickLength: 5,
                bands: [],
            },
        ];
        this.allLabels = [];
        this.balloon = {};
        this.titles = [];
    }
};
