/** ***********************************************************************
 *
 * Veracity Technology Consultants CONFIDENTIAL
 * __________________
 *
 *  2017 Veracity Technology Consultants
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Veracity Technology Consultants and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Veracity Technology Consultants
 * and its suppliers and may be covered by U.S. and Foreign Patents,
 * patents in process, and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Veracity Technology Consultants.
 */
const graphConfig = require('./graphConfig.js');

function truncate(valueText, length)
{
    if (valueText.length > length) return `${valueText.substring(0, length)}...`;
    return valueText;
}
module.exports = class multilineChart extends graphConfig
{
    constructor(lines, categoryField)
    {
        super('graph');
        this.type = 'serial';
        this.engine = 'amcharts';
        this.marginBottom = 10;
        this.marginLeft = 10;
        this.marginRight = 10;
        this.marginTop = 10;
        this.categoryField = categoryField;
        this.rotate = false;
        this.responsive = {
            enabled: true,
        };
        this.balloon = {
            "borderThickness": 0,
            "borderAlpha": 0,
            "fillAlpha": 0,
            "horizontalPadding": 0,
            "verticalPadding": 0,
            "shadowAlpha": 0
        }
        this.categoryAxis = {
            gridPosition: 'start',
            axisColor: '#DADADA',
            parseDates: false,
            minPeriod: 'DD',
            truncateLabel: 20,
            gridAlpha: 0.02,
        };
        this.valueAxes = [];

        for (const i in lines)
        {
            this.valueAxes.push({
            axisAlpha: 0.2,
            gridAlpha: 0.02,
            id:"v"+i,
            offset:50 * i
            });
        }
        this.graphs = [];
        for (const i in lines)
        {
            this.graphs.push(
            {
                type: 'line',
                valueAxis: "v"+i,
                title: truncate(lines[i], 30),
                valueField: lines[i],
                bullet: 'round',
                bulletSize: 4,
                lineAlpha: 1,
                lineThickness: 1.01,
                //  "balloonText": "[[" + categoryField + "]]:<b>[[" + lines[i] + "]]</b>",
                id: `g${i}`,
                //  "balloonCategoryFormat": "Date"
            });
        }
        this.legend = {
            position: 'right',
            truncateLabels: 20,
            autoMargins: true,
        };
        this.chartScrollbar = {
            graph: 'g1',
            oppositeAxis: false,
            offset: 30,
            scrollbarHeight: 80,
            backgroundAlpha: 0,
            selectedBackgroundAlpha: 0.1,
            selectedBackgroundColor: '#888888',
            graphFillAlpha: 0.31,
            graphLineAlpha: 0.0,
            graphLineThickness: 1.01,
            selectedGraphFillAlpha: 0,
            selectedGraphLineAlpha: 0.0,
            selectedGraphLineThickness: 1.01,
            autoGridCount: true,
            color: '#AAAAAA',
        };
        this.update = function(params)
        {
            if (params && params.__preparse && params.__preparse.span == 'hourly')
            {
                this.categoryAxis.minPeriod = 'hh';
            }
        }
    }
};