/** ***********************************************************************
 *
 * Veracity Technology Consultants CONFIDENTIAL
 * __________________
 *
 *  2017 Veracity Technology Consultants
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Veracity Technology Consultants and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Veracity Technology Consultants
 * and its suppliers and may be covered by U.S. and Foreign Patents,
 * patents in process, and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Veracity Technology Consultants.
 */
const graphConfig = require('./graphConfig.js');
module.exports = class PieGraph extends graphConfig {
    constructor(categoryField, valueField) {
        super('graph');
        this.type = 'pie';
        this.engine = 'amcharts';
        this.startDuration = 0;
        this.theme = 'light';
        this.addClassNames = true;
        this.innerRadius = '30%';
        this.valueField = valueField;
        this.titleField = categoryField;
        this.labelsEnabled = false;
        this.marginBottom = 10;
        this.marginLeft = 10;
        this.marginRight = 10;
        this.marginTop = 10;
        //  this.startEffect = "easeInSine";
        this.responsive = {
            enabled: true,
        };
        // this.startDuration = 1;
        this.legend = {
            position: 'right',
            truncateLabels: 40,
            autoMargins: true,
        };
        this.defs = {
            filter: [{
                id: 'shadow',
                width: '200%',
                height: '200%',
            }, ],
        };
        this.export = {
            enabled: true,
        };
        this.balloon= {
            "borderThickness": 0,
            "borderAlpha": 0,
            "fillAlpha": 0,
            "horizontalPadding": 0,
            "verticalPadding": 0,
            "shadowAlpha": 0
        }
    }
};