/** ***********************************************************************
 *
 * Veracity Technology Consultants CONFIDENTIAL
 * __________________
 *
 *  2017 Veracity Technology Consultants
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Veracity Technology Consultants and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Veracity Technology Consultants
 * and its suppliers and may be covered by U.S. and Foreign Patents,
 * patents in process, and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Veracity Technology Consultants.
 */

const graphConfig = require('./graphConfig.js');

module.exports = class SerialGraph extends graphConfig {
    constructor(categoryField, valueField) {
        super('graph');
        this.type = 'serial';
        this.engine = 'amcharts';
        this.categoryField = categoryField;
        this.rotate = false;
        this.responsive = {
            enabled: true,
        };
        this.marginBottom = 0;
        this.marginLeft = 0;
        this.marginRight = 0;
        this.marginTop = 0;
        (this.categoryAxis = {
            gridPosition: 'start',
            gridAlpha: 0.02,
            axisColor: '#DADADA',
            parseDates: false,
            minPeriod: 'DD',
        }),
            (this.valueAxes = [
                {
                    axisAlpha: 0.2,
                    gridAlpha: 0.02,
                },
            ]);
        this.graphs = [
            {
                type: 'line',
                title: 'Completions',
                valueField,
                lineAlpha: 1,
                lineThickness: 1.01,
                lineColor: '#39cafa',
                fillColors: '#39cafa',
                fillAlphas: 0.6,
                balloonText: `[[${categoryField}]]:<b>[[${valueField}]]</b>`,
                balloonCategoryFormat: 'Date',
                id: 'g1',
            },
        ];
        
    }
  
};
