/** ***********************************************************************
 *
 * Veracity Technology Consultants CONFIDENTIAL
 * __________________
 *
 *  2017 Veracity Technology Consultants
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Veracity Technology Consultants and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Veracity Technology Consultants
 * and its suppliers and may be covered by U.S. and Foreign Patents,
 * patents in process, and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Veracity Technology Consultants.
 */

const graphConfig = require('./graphConfig.js');

module.exports = class SparkLine extends graphConfig {
    constructor(categoryField, valueField) {
        super('sparkline');
        this.type = 'serial';
        this.engine = 'amcharts';
        this.theme = 'light';
        this.categoryField = categoryField;
        this.autoMargins = false;
        this.marginBottom = 10;
        this.marginLeft = 10;
        this.marginRight = 10;
        this.marginTop = 10;
        this.responsive = {
            enabled: true,
        };
        this.marginBottom = 0;
        this.graphs = [
            {
                valueField,
                bulletField: 'bullet',
                showBalloon: false,
                lineColor: '#a9ec49',
                lineThickness: 5,
            },
        ];
        this.valueAxes = [
            {
                gridAlpha: 0,
                axisAlpha: 0,
            },
        ];
        this.categoryAxis = {
            gridAlpha: 0,
            axisAlpha: 0,
            startOnAxis: true,
        };
    }
};
