/** ***********************************************************************
 *
 * Veracity Technology Consultants CONFIDENTIAL
 * __________________
 *
 *  2017 Veracity Technology Consultants
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Veracity Technology Consultants and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Veracity Technology Consultants
 * and its suppliers and may be covered by U.S. and Foreign Patents,
 * patents in process, and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Veracity Technology Consultants.
 */
const graphConfig = require('./graphConfig.js');
module.exports = class BarGraph extends graphConfig {
    constructor(categoryField, stacks, valueField) {
        super('graph');
        if (stacks.constructor !== Array) throw new Error('the second parameter to a stacked bar chart should be an array of categoryField strings');
        this.engine = 'amcharts';
        this.marginBottom = 10;
        this.marginLeft = 10;
        this.marginRight = 10;
        this.marginTop = 10;
        this.type = 'serial';
        this.labelsEnabled = true;
        this.categoryField = categoryField;
        this.rotate = false;
        this.theme = 'light';
        this.categoryAxis = {
            gridPosition: 'start',
            gridAlpha: 0.02,
            rotateLabels: 80,
            autoRotateCount: 5,
            autoRotateAngle: 45,
            truncateLabel: 20,
        };
        this.balloon = {
            "borderThickness": 0,
            "borderAlpha": 0,
            "fillAlpha": 0,
            "horizontalPadding": 0,
            "verticalPadding": 0,
            "shadowAlpha": 0
        }
        this.valueAxes = [{
            axisAlpha: 0.2,
            gridAlpha: 0.02,
            stackType: 'regular',
        }, ];
        this.graphs = [];
        for (const i in stacks) {
            this.graphs.push({
                type: 'column',
                title: stacks[i],
                autoColor: true,
                valueField: stacks[i],
                lineAlpha: 0,
                labelText: stacks[i],
                fillAlphas: 0.8,
                balloonText: `[[${categoryField}]]:<b>[[${stacks[i]}]][[${valueField}]]</b>`,
            });
        }
        this.legend = {
                position: 'right',
                truncateLabels: 40,
                autoMargins: true,
            };
        this.update = function(params,data)
        {
            console.log(data);
            if(data.length < 20)
                this.display = "three_x_one"
            if(data.length < 15)
                this.display = "two_x_one"
            if(data.length < 10)
                this.display = "one_x_one"

            console.log(this.display)
        }
    }
};